package at.tugraz.iaik.p2p.kademlia.message;

import at.tugraz.iaik.p2p.kademlia.KadConfiguration;
import at.tugraz.iaik.p2p.kademlia.KademliaNode;
import at.tugraz.iaik.p2p.kademlia.node.Node;
import at.tugraz.iaik.p2p.kademlia.KadServer;

import java.io.IOException;

/**
 * Default receiver if none other is called
 *
 * @author Joshua Kissoon
 * @created 20140202
 */
public class PingReceiver implements Receiver {


    private final KadServer server;
    private final KademliaNode localNode;
    private final KadConfiguration config;

    public PingReceiver(final KadServer server, final KademliaNode local, final KadConfiguration config) {
        this.server = server;
        this.localNode = local;
        this.config = config;
    }

    @Override
    public void receive(final Message incoming, final int conversationId) {
        final Node origin = incoming.getOrigin();

        /* Update the local space by inserting the origin node. */
        this.localNode.getRoutingTable().insert(incoming);
        //todo: PONG

    }

    @Override
    public void timeout(final int conversationId) throws IOException {
        System.out.println("SimpleReceiver message timeout.");
    }
}
