package at.tugraz.iaik.p2p.kademlia.message;

import at.tugraz.iaik.p2p.kademlia.node.Node;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

/**
 * A simple message used for testing the system; Default message constructed if the message type sent is not available
 *
 * @author Joshua Kissoon
 * @created 20140217
 */
public class SimpleMessage extends Message {


    private final String content;

    public SimpleMessage(Node origin, Node target, int commID, final String message) {
        super(origin, target, MsgCode.SIMPLE, commID);
        this.content = message;
    }

    SimpleMessage(final DataInputStream in) throws IOException {
        super(MsgCode.SIMPLE, in);
        final byte[] buff = new byte[in.readInt()];
        in.readFully(buff);
        this.content = new String(buff);
    }


    @Override
    public void toStream(final DataOutputStream out) throws IOException {
        super.toStream(out);
        try {
            out.writeInt(this.content.length());
            out.writeBytes(this.content);
        } catch (final IOException e) {
            e.printStackTrace();
        }
    }


    @Override
    public String toString() {
        return super.toString() + ", SimpleMessage] content: \"" + this.content + "\"";
    }
}
